package com.ashokit.stack;

import java.util.Stack;

public class StackExample {
	
	public static void main(String[] args) throws Exception {
		
		Stack<Integer> s=new Stack<>();//Object[]
		s.add(10);//1
		s.add(0);//2
		s.add(20);//3
		s.add(30);//4
		s.add(60);//5
		s.add(70);//6
		s.push(80);//7
		System.out.println(s);
		System.out.println(s.peek());
		System.out.println(s.peek());
		System.out.println(s.peek());//get(index-1)
		System.out.println(s.pop());//6
		System.out.println(s);
		System.out.println(s.peek());
		System.out.println(s.pop());//5
		System.out.println(s);
		System.out.println(s.pop());//4
		System.out.println(s);
		System.out.println(s.pop());//3
		System.out.println(s);
		System.out.println(s.pop());//2
		System.out.println(s);
		System.out.println(s.pop());//1
		System.out.println(s);//0-1element
		System.out.println(s.pop());//0
		System.out.println(s);//empty
	//	System.out.println(s.pop());//-1
		//pop(), peek on empty stack-> Empty Stack expception
		
		
		System.out.println("Custom Stack ");
		CustomStackUsingArray cs= new CustomStackUsingArray(5);
		cs.insert(10);//1
		cs.insert(0);//2
		cs.insert(9);//3
		cs.insert(1);//4
		cs.insert(20);//5
		System.out.println(cs);
		System.out.println(cs.pop());
		System.out.println(cs);
		System.out.println(cs.pop());
		System.out.println(cs);
		System.out.println(cs.pop());
		System.out.println(cs);
		System.out.println(cs.pop());
		System.out.println(cs);
		System.out.println(cs.pop());
		
		StackUsingLinkedList sl= new StackUsingLinkedList();
		sl.add(10);
		sl.add(0);
		sl.add(9);
		sl.add(1);
		sl.add(20);
		System.out.println("Stack Using LinkedList");
		System.out.println("s1 "+sl);
		System.out.println(sl.peek());
		System.out.println("s1 "+sl);
		System.out.println(sl.pop());
		System.out.println("s1 "+sl);
		System.out.println(sl.pop());
		System.out.println("s1 "+sl);
		System.out.println(sl.pop());
		System.out.println("s1 "+sl);
		System.out.println(sl.pop());
		System.out.println("s1 "+sl);
		/*
		 * System.out.println(sl.pop()); System.out.println("s1 "+sl);
		 */
	}

}
